
var DragInfoGraphicPoints = null;

(function($){
  
  DragInfoGraphicPoints = DragInfoGraphic.extend({
      
     init: function(options) {
		 this.defaults = {
		     canvas: '#dragGraphicCanvas',
		     button: '#next',
		     space: 10,
		     zones: [
				 {node:"#zone1", className:"leftTop", label: 'quatschen & teilen', color: '##12C0E7', width:"49%", height:"48%", top:0, left:0, padding:'77px 10px 10px 10px'},
				 {node:"#zone2", className:"rightTop", label: 'Spiel & Spaß', color: '#ff8100', width:"49%", height:"48%", top:0, left:"51%", padding:'77px 10px 10px 10px'},
				 {node:"#zone3", className:"leftBottom", label: 'suchen & finden', color: '#95C11E', width:"49%", height:"49%", top:"51%", left:0, padding:'77px 10px 10px 10px'},
				 {node:"#zone4", className:"rightBottom", label: 'entwerfen & kreieren', color: '#bd48cb', width:"49%", height:"49%", top:"51%", left:"51%", padding:'77px 10px 10px 10px'}
		     ],
		     statusNode: '#zonebudget',
		     iconBar: '#bar',
		     icons: [
                                {glyph: 'Angry-Birds.png', info: 'Angry-Birds'},
                                {glyph: 'Bing-Maps.png', info: 'Bing Maps'},
                                {glyph: 'Candy-Crush.png', info: 'Candy-Crush'},
				{glyph: 'Apple-sms.png', info: 'Apple-SMS'},
                                {glyph: 'Gmail.png', info: 'Gmail'},
                                {glyph: 'Google-Maps.png', info: 'Google-Maps'},
                                {glyph: 'Google.png', info: 'Google'},
				{glyph: 'Instagram.png', info: 'Instagram'},
                                {glyph: 'Jappy.png', info: 'Jappy'},
                                {glyph: 'Kamera.png', info: 'Kamera'},
                                {glyph: 'Mail-Apple.png', info: 'Mail Apple'},
                                {glyph: 'SMS-Android.png', info: 'SMS-Android'},
                                {glyph: 'Safari.png', info: 'Safari'},
				{glyph: 'Skype.png', info: 'Skype'},
                                {glyph: 'SnapChat.png', info: 'SnapChat'},
				{glyph: 'Spotify.png', info: 'Spotify'},
                                {glyph: 'Twitter.png', info: 'Twitter'},
                                {glyph: 'Viber.png', info: 'Viber'},
                                {glyph: 'Wahtsapp.png', info: 'WhatsApp'},
                                {glyph: 'Wikipedia.png', info: 'Wikipedia'},
                                {glyph: 'YouTube.png', info: 'YouTube'},
                                {glyph: 'bing.png', info: 'Bing'},
                                {glyph: 'facebook.png', info: 'Facebook'},
                                {glyph: 'last-fm.png', info: 'Last-Fm'},
                                {glyph: 'myVideo.png', info: 'myVideo'},
                                {glyph: 'Apple-Karten.png', info: 'Appel Maps'},
                                {glyph: 'Game-Center-Apple.png', info: 'Gamecenter Appel'},
                                {glyph: 'FB-Messenger.png', info: 'Facebook Messenger'},
                                {glyph: 'Google-play.png', info: 'Google-Play'},
                                {glyph: 'Flickr.png', info: 'Flickr'}
                                
		     ],
		     matrix: [
				{ zone1: 'red', zone2: 'green', zone3: 'red', zone4: 'red'}, //Angry-Birds
                                { zone1: 'red', zone2: 'red', zone3: 'green', zone4: 'red'}, //Bing-Maps
                                { zone1: 'red', zone2: 'green', zone3: 'red', zone4: 'red'}, //Candy-Crush
                                { zone1: 'green', zone2: 'yellow', zone3: 'red', zone4: 'yellow'}, //SMS schreiben
                                { zone1: 'green', zone2: 'yellow', zone3: 'yellow', zone4: 'yellow'}, //Gmail
                                { zone1: 'red', zone2: 'red', zone3: 'green', zone4: 'red'}, //Google-Maps
                                { zone1: 'red', zone2: 'yellow', zone3: 'green', zone4: 'red'}, //Google
                                { zone1: 'green', zone2: 'green', zone3: 'yellow', zone4: 'green'}, //Instagram
                                { zone1: 'green', zone2: 'green', zone3: 'yellow', zone4: 'yellow'}, //Jappy
                                { zone1: 'red', zone2: 'green', zone3: 'red', zone4: 'green'}, //Kamera
                                { zone1: 'green', zone2: 'yellow', zone3: 'yellow', zone4: 'yellow'}, //Mail-Apple
                                { zone1: 'green', zone2: 'yellow', zone3: 'red', zone4: 'yellow'}, //SMS-Android
                                { zone1: 'yellow', zone2: 'green', zone3: 'green', zone4: 'red'}, //Safari
                                { zone1: 'green', zone2: 'yellow', zone3: 'red', zone4: 'yellow'}, //Skype
                                { zone1: 'green', zone2: 'green', zone3: 'red', zone4: 'green'}, //SnapChat
                                { zone1: 'yellow', zone2: 'green', zone3: 'green', zone4: 'red'}, //Spotify
                                { zone1: 'green', zone2: 'yellow', zone3: 'yellow', zone4: 'yellow'}, //Twitter
                                { zone1: 'green', zone2: 'yellow', zone3: 'red', zone4: 'yellow'}, //Viber
                                { zone1: 'green', zone2: 'yellow', zone3: 'red', zone4: 'yellow'}, //Wahtsapp
                                { zone1: 'red', zone2: 'yellow', zone3: 'green', zone4: 'yellow'}, //Wikipedia
                                { zone1: 'yellow', zone2: 'yellow', zone3: 'green', zone4: 'green'}, //YouTube
                                { zone1: 'red', zone2: 'yellow', zone3: 'green', zone4: 'red'}, //Bing
                                { zone1: 'green', zone2: 'green', zone3: 'yellow', zone4: 'yellow'}, //Facebook
                                { zone1: 'yellow', zone2: 'green', zone3: 'yellow', zone4: 'yellow'}, //Last-Fm
                                { zone1: 'yellow', zone2: 'yellow', zone3: 'green', zone4: 'green'},  //myVideo
                                { zone1: 'red', zone2: 'red', zone3: 'green', zone4: 'red'},  //Appel-Maps
                                { zone1: 'yellow', zone2: 'green', zone3: 'red', zone4: 'red'},  //Gamecenter-Appel
                                { zone1: 'green', zone2: 'yellow', zone3: 'red', zone4: 'red'},  //FB-Messenger
                                { zone1: 'yellow', zone2: 'green', zone3: 'red', zone4: 'red'},  //Google-Play
                                { zone1: 'green', zone2: 'green', zone3: 'yellow', zone4: 'green'}  //Flickr
		     ],
		     resultTexte: {
				 red: { img:'/img/igraph/k_red.jpg', text: 'Ups!', text2: 'Vielleicht schaust du dir die Apps noch einmal genauer an?'},
				 yellow: { img:'/img/igraph/k_yellow.jpg', text: 'Ok!', text2: 'Du kennst dich aus und bist auf dem richtigen Weg!'},
				 green: { img:'/img/igraph/k_green.jpg', text: 'Super!', text2: 'Du weißt ja richtig gut Bescheid, weiter so!'}
		     },
		     iconViewLength: 6
		 }
		 
		 this.opt = $.extend(this.defaults, options);	 
		 this._super(this.opt);	 
     },
     
     createViews: function() {
		 var self = this;
		 this._super();
		 this.opt.iconBar.find('.icon').each(function(i, elem) {
		     $(elem).attr('matrix_index', i);
		 });
     },
     
     initZoneDrags: function() {
		 var self = this;
		 this._super();		
		 $('.icon').tooltip({title: 'title'});
		 this.opt.canvas.find('.zone .icon').each(function(i, elem) {
		     var item = self.getItem ( $(elem).attr('item_id') );
		     item.hideSmallView();
		 });
     },
     
     openDialog: function() {
    	 var self = this;
    	 var status = this.updateStatus();
    	 this.status = status;
    	 
		 $( "#g_header" ).html(this.opt.resultTexte[status].text);
		 $( "#g_cont" ).html(
				 //'<h2>'+this.opt.resultTexte[status].text+"</h2>"
				 //+'<img src="'+this.opt.resultTexte[status].img+'" style="padding:10px 0px;"/>'
				 this.opt.resultTexte[status].text2
		 );
		 $('#g_dialog').on('hidden', function () {
			//window.location.href = self.opt.gotoUrl;
		 });
		 $( "#g_dialog" ).modal('show');
     },
     
     createItem: function(node) {
		 this.itemStackIndex++;
		 
		 var item = new DragPointItem({
		     canvas: node,
		     id: this.itemStackIndex,
		     control: this
		 });
		 this.itemStack.push(item);
		 return item;
     },
     
     
     updateStatus: function() {
		var self = this;
		 
		 var redExists = false;
		 var points = 0;
		 for(var i=0; i < this.opt.zones.length; i++) {
		     this.opt.zones[i].node.find('.icon').each(function(y, elem) {
			 var item = self.getItem( $(elem).attr('item_id') );
			 item.setSmallView();
			 var status = item.getStatus();
			 switch(status) {
			    case 'green':
				 points++;
				 break;
			    case 'red':
				 points--;
				 redExists=true;
				 break;
			    case 'yellow':
				 points += 0.5;
				 break; 
			 }
		     }); 
		 }
		 
		 this.opt.statusNode.removeClass('red');
		 this.opt.statusNode.removeClass('yellow');
		 this.opt.statusNode.removeClass('green');
		 
		 if(redExists) {
		     if(points >= 0) {
			 this.opt.statusNode.addClass('yellow');
			return 'yellow';
		     }else {
			this.opt.statusNode.addClass('red');
			return 'red';
		     }
		 }else {	     
		     if(points == 0){
			 this.opt.statusNode.addClass('yellow');
			 return 'yellow';
		     }else {
			 this.opt.statusNode.addClass('green');
			 return 'green';
		     }
		 }
	 
     },
     
     getJson: function() {
		 var value = Array();	 
		 for(var i=0; i < this.itemStack.length; i++) {
		     var obj = {
			zone: '',
			matrix_index: '',
			classNames: '',
			iconHtml: '',
			opt: null
		     };
		     
		     obj.zone = '#'+this.itemStack[i].opt.canvas.parent().attr("id");
		     obj.matrix_index = this.itemStack[i].opt.canvas.attr('matrix_index');
		     obj.classNames = this.itemStack[i].opt.canvas.attr('class');
		     obj.iconHtml = '<span class="'+this.itemStack[i].opt.canvas.find('span:first').attr('class')+'"><i></i></span>';
		     obj.opt = jQuery.extend({}, this.itemStack[i].opt);
		     obj.opt.canvas = null;
		     obj.opt.control = null;
		     value.push(obj);
		 }	 
		 
		 console.log( JSON.stringify(value) );
		 return JSON.stringify(value);
     },
     
     loadJson: function(str) {
    	 var self = this;
		 //var str = [{"zone":"#zone4","matrix_index":"4","classNames":"icon ui-draggable inzone","iconHtml":"<span class=\"glyphicons binoculars\"><i></i></span>","opt":{"canvas":null,"id":1,"type":null,"data":{"desc":"","price":0},"control":null}},{"zone":"#zone2","matrix_index":"5","classNames":"icon ui-draggable inzone","iconHtml":"<span class=\"glyphicons road\"><i></i></span>","opt":{"canvas":null,"id":2,"type":null,"data":{"desc":"","price":0},"control":null}},{"zone":"#zone3","matrix_index":"1","classNames":"icon ui-draggable inzone","iconHtml":"<span class=\"glyphicons fire\"><i></i></span>","opt":{"canvas":null,"id":3,"type":null,"data":{"desc":"","price":0},"control":null}},{"zone":"#zone3","matrix_index":"2","classNames":"icon ui-draggable inzone","iconHtml":"<span class=\"glyphicons magnet\"><i></i></span>","opt":{"canvas":null,"id":4,"type":null,"data":{"desc":"","price":0},"control":null}},{"zone":"#zone1","matrix_index":"3","classNames":"icon ui-draggable inzone","iconHtml":"<span class=\"glyphicons parents\"><i></i></span>","opt":{"canvas":null,"id":5,"type":null,"data":{"desc":"","price":0},"control":null}}];
		 var value = str;
		 
		 for(var i=0; i < value.length; i++) {
		     try { 
                        var node = $('<div title="'+self.opt.icons[value[i].matrix_index].info+'" class="'+value[i].classNames+'" matrix_index="'+value[i].matrix_index+'">'+value[i].iconHtml+'</div>');
                        value[i].opt.canvas = node;
                        value[i].opt.control = this;
                        $(value[i].zone).append(node);
                        var item = this.createItem(node, value[i].opt);
                    }catch(e){
                        return;
                    }
		 }
		 
		 this.initZoneDrags();
		 this.updateStatus();
     }      
     
  });

})(jQuery);